/**
 * Represents original substituted subject member type
 * @public
 */
export const callInfo = Object.freeze({
    /**
     * Indicates method member type substitution
     */
    method: 1,
    /**
     * Indicates getter member type substitution
     */
    getter: 2,
    /**
     * Indicates setter member type substitution
     */
    setter: 3,
    /**
     * Indicates substitution for both getter and setter member types
     */
    getterSetter: 4,
    /**
     * Indicates substitution of any member type
     */
    any: 5,
    /**
     * Indicates field substitution
     */
    field: 6
});
