import { setPrototypeOf } from './common.js';
/**
 * Represents general purpose application error
 * @public
 */
export class ApplicationError extends Error {
    /**
     * Constructor
     * @param params - optional additional information about the error
     * @returns - an instance of ApplicationError
     */
    constructor(params) {
        super(params ? params.message : undefined);
        setPrototypeOf(this, ApplicationError.prototype);
        this.name = 'Application Error';
        this._data = params ? params.data : undefined;
    }
    get data() {
        return this._data;
    }
}
