import { ApplicationError } from './application-error.js';
import { setPrototypeOf } from './common.js';
/**
 * Represents argument error. It is thrown when the argument value does not
 * comply with the method specification
 * @public
 */
export class ArgumentError extends ApplicationError {
    /**
     * Constructor
     * @param argumentName - argument name
     * @param params - optional additional information about the error
     * @returns - an instance of ArgumentError
     */
    constructor(argumentName, params) {
        super(params);
        setPrototypeOf(this, ArgumentError.prototype);
        this.name = 'Argument Error';
        this._argumentName = argumentName;
    }
    get argumentName() {
        return this._argumentName;
    }
}
