/**
 * Dependency injection container for TypeScript / JavaScript
 *
 * @packageDocumentation
 */
import 'reflect-metadata';
import { Scaffold } from './scaffold/index.js';
const scaffold = new Scaffold();
/**
 * Creates an instance on {@link IContainerBuilder} interface
 * @public
 * @returns - an instance on {@link IContainerBuilder} interface
 */
export const builder = () => scaffold.createBuilder();
/**
 * Creates an instance on {@link IDecorator} interface
 * @public
 * @returns - an instance on {@link IDecorator} interface
 */
export const decorator = () => scaffold.createDecorator();
/**
 * Creates an instance on {@link IInterceptor} interface
 * @public
 * @returns - an instance on {@link IInterceptor} interface
 */
export const interceptor = () => scaffold.createInterceptor();
export { scope, callInfo } from './common/index.js';
export { ApplicationError, ArgumentError, CircularDependencyError, DecoratorError, ProxyError, ResolutionError } from './exceptions/index.js';
