export class DisposableStorage {
    constructor() {
        this._disposables = [];
    }
    add(obj, disposer) {
        const item = this.createDisposableItem(obj, disposer);
        this._disposables.push(item);
    }
    disposeItems() {
        while (this._disposables.length > 0) {
            const item = this._disposables.pop();
            const obj = item.weakReference;
            item.disposer(obj);
        }
    }
    createDisposableItem(obj, disposer) {
        return {
            weakReference: obj,
            disposer
        };
    }
}
