import { HashTable } from 'hashes';
export class InternalStorage {
    constructor() {
        this._collection = new HashTable();
    }
    add(key, value) {
        this._collection.add(key, value, true);
    }
    get(key) {
        return this._collection.get(key).value;
    }
    tryGet(key) {
        return this.contains(key) ? this._collection.get(key).value : undefined;
    }
    register(key, defaultValue) {
        if (this.contains(key)) {
            return this._collection.get(key).value;
        }
        const entry = defaultValue();
        this.add(key, entry);
        return entry;
    }
    contains(key) {
        return this._collection.contains(key);
    }
    clear() {
        this._collection.clear();
    }
}
