export function getMetadata(type) {
    return Reflect.getMetadata('design:paramtypes', type) || [];
}
export function construct(constructor, args) {
    return args && args.length ? new constructor(...args) : new constructor();
}
export function isArray(value) {
    return Array.isArray(value);
}
export function isFunction(f) {
    return f instanceof Function;
}
export function isPrototype(f) {
    return toString.call(f) === '[object Function]';
}
export function isObject(o) {
    return o === Object(o);
}
export function getPropertyDescriptor(object, key) {
    let descriptor;
    do {
        descriptor = Object.getOwnPropertyDescriptor(object, key);
    } while (!descriptor && (object = Object.getPrototypeOf(object)));
    return descriptor;
}
export function getAllPropertyNames(obj) {
    const props = [];
    do {
        Object.getOwnPropertyNames(obj).forEach((prop) => {
            if (props.indexOf(prop) === -1) {
                props.push(prop);
            }
        });
    } while (obj = Object.getPrototypeOf(obj));
    return props;
}
